/*
 * CAN.h
 *
 *  Created on: 23 Jul 2019
 *      Author: kentm
 */

#ifndef CAN_H_
#define CAN_H_
// ******************** includes **********************************************
#include "stm32f4xx.h"
#include "stm32f4xx_rcc.h"
#include "stm32f4xx_gpio.h"
#include "canard.h"
#include "canard_stm32.h"


// ******************** typedefs and defines **********************************
typedef struct{
	uint32_t CAN_APB1Periph;
	uint8_t	 CAN_AF;
	uint32_t GPIO_AHB1Periph;
	GPIO_TypeDef *GPIO_PORT;
	uint16_t RX_GPIO_Pin;
	uint16_t TX_GPIO_Pin;
	uint8_t  RX_GPIO_PinSource;
	uint8_t  TX_GPIO_PinSource;
} CAN_Init_t;

#define CAN_INIT \
{\
	{RCC_APB1Periph_CAN1,GPIO_AF_CAN1  ,RCC_AHB1Periph_GPIOD,GPIOD,GPIO_Pin_0,GPIO_Pin_1,GPIO_PinSource0,GPIO_PinSource1},\
	{RCC_APB1Periph_CAN2,GPIO_AF_CAN2  ,RCC_AHB1Periph_GPIOB,GPIOB,GPIO_Pin_5,GPIO_Pin_6,GPIO_PinSource5,GPIO_PinSource6},\
	{RCC_APB1Periph_CAN3,GPIO_AF11_CAN3,RCC_AHB1Periph_GPIOA,GPIOA,GPIO_Pin_8,GPIO_Pin_15,GPIO_PinSource8,GPIO_PinSource15},\
}

// ******************** exported function prototypes **************************
void CANInit(CAN_Init_t * Init);
void CANDeInit(CAN_Init_t * Init);
void CANswInit(PortCAN_t Port,CanardInstance* out_ins,void* mem_arena,size_t mem_arena_size,CanardOnTransferReception on_reception,
			CanardShouldAcceptTransfer should_accept,uint8_t self_node_id,const CanardSTM32AcceptanceFilterConfiguration* const filter_configs, uint16_t filtLen);

// ******************** end of CAN.h *********************************** 	
#endif /* CAN_H_ */
