/*
 * kocherga_defs.h
 *
 *  Created on: Nov 6, 2019
 *      Author: kentm
 */

#ifndef KOCHERGA_DEFS_H_
#define KOCHERGA_DEFS_H_
// ******************** includes **********************************************
#include <stdint.h>
#include "System_Config.h"
// ******************** typedefs and defines **********************************
#define UNIX_TIMESTAMP (0x55555555)


#define  FlagReleaseBuild 1
#define  FlagDirtyBuild   2
typedef struct
{
		// Offset 0 bytes
		uint8_t APDesc[8];			// always "APDesc00"
    // Offset 8 bytes
    uint64_t image_crc;        ///< CRC-64-WE of the firmware image padded to 8 bytes while this field zero
    // Offset 16 bytes
    uint32_t image_size    ;        ///< Size of the application image in bytes
    // Offset 20 bytes
    uint32_t vcs_commit    ;        ///< Version control system revision ID (e.g. git commit hash)
    // Offset 24 bytes
    uint8_t  major_version ;        ///< Major semantic version number
    // Offset 25 bytes
    uint8_t  minor_version ;        ///< Minor semantic version number
    // Offset 26 bytes
    uint8_t  flags ;             ///< Flags: 1 - release build, 2 - dirty build
    // Offset 27 bytes
    uint8_t  _reserved_a_ ;         ///< Reserved for future use
    // Offset 28 bytes
    uint32_t build_timestamp_utc ;  ///< UTC Unix time in seconds when the application was built
    // Offset 32 bytes
}AppInfo_t;
#define APPINFO {.image_crc=0,.APDesc={'A','P','D','e','s','c','0','0'},.image_size=0,.vcs_commit=GIT_HASH,\
								.major_version=APP_VERSION_MAJOR,.minor_version=APP_VERSION_MINOR,.flags=FlagReleaseBuild,\
	              ._reserved_a_=0xff,.build_timestamp_utc=UNIX_TIMESTAMP}
// ******************** exported function prototypes **************************
void kocherga_defs_Init(void);
// ******************** end of kocherga_defs.h *********************************** 	
#endif /* KOCHERGA_DEFS_H_ */
